/*
 * Created on Dec 10, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package AccordionSequenceDrawer;

/**
 * @author jslack
 *
 * ColumnColorSet: element of a range of sequences that share the same (popular) color value over some range of sites
 *
 * This is the component of the ColumnColorList treeSet.  This component is created from sequential
 * identical colors found from the most popular siteNodes in a ColumnNumberSet while changing a
 * columnNumberList (list of <array of tallies for each siteNode type> for all sequences) into a
 * columnColorList (tree of colors for sequential sequences that share the same color value).
 * 
 */
public class ColumnColorSet implements Comparable {

	char colorLetter;
	int minSeq, maxSeq;
	static boolean getColor = false;
	static ColumnColorSet returnColorSet = null;
	
	public ColumnColorSet(char colorLetter, int minSeq, int maxSeq)
	{
		this.colorLetter = colorLetter;
		this.minSeq = minSeq;
		this.maxSeq = maxSeq;
	}

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(Object o) {
		ColumnColorSet other = (ColumnColorSet)o;
		if (other.maxSeq < minSeq)
			return 1;
		if (other.minSeq > maxSeq)
			return -1;
		if (getColor)
		{
			returnColorSet = other;
		}
		getColor = false; // auto reset
		return 0; // overlap
	}
	
	public String toString()
	{
		return "[" + minSeq + ", " + maxSeq + ", " + colorLetter + "]";
	}
	
	
}
