/*
 * Created on 11-Dec-2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package AccordionSequenceDrawer;

import java.awt.Color;
import java.util.*;

import AccordionDrawer.SplitCell;
import AccordionDrawer.SplitLine;
import AccordionDrawer.OlduvaiObject;


/**
 * @author hilde
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Sequence implements OlduvaiObject  {
	
	public static int maxFound;
	
	ArrayList sites;
	String name;
	Vector annotationList;
	AccordionSequenceDrawer asd;
	// this bitset corresponds to the ArrayList
	// while parsing it is set if the region on the complement
	// DNA/RNA strang or not
	//Vector exonComplement, intronComplement; 
	
	SequenceStringIterator seqIter;
	int endNumOfNodes;
	int key;
	public boolean seqLabelDrawn = false;

	private static final int A = 0;

	private static final int T = 1;

	private static final int C = 2;

	private static final int G = 3;

	private static final int U = 4;

	private static final int N = 5;

//	public static final char letter[] = {'A', 'T', 'C', 'G', 'U', 'N'};
	public static final String letters = "ATCGUN";

	private static Color col[] = { Color.getHSBColor(120f/360f,.39f,0.93f), // A 
			Color.getHSBColor(350f/360f,.32f,0.93f), // T
			Color.getHSBColor(215f/360f,.21f,0.87f), // C
			Color.getHSBColor(50f/360f,.45f,1.0f),  // G
			Color.getHSBColor(180f/360f,.26f,0.93f), // U
			Color.getHSBColor(0f/360f,0f,0.75f)}; // N

	public static Color gapColor = Color.white;

	public static Color diffColor = Color.red;

	public static Color foundColor = Color.black; //Color.magenta;
	
	
	//public Sequence(org.biojava.bio.seq.Sequence seq, int key){
	public Sequence(String seqName, ArrayList seqList, int key){
		this.key = key;
		sites = new ArrayList();
		annotationList = new Vector();
		
		name = seqName;
		
		//seqDataList = seqList;
		seqIter = new SequenceStringIterator( seqList );
		
		endNumOfNodes = seqIter.getNumOfChars();
		}
	
	public Sequence(String seqName, ArrayList seqList, Vector annotations, int key){
			this.key = key;
			sites = new ArrayList();
			name = seqName;
			annotationList = annotations;			
			seqIter = new SequenceStringIterator( seqList );
			endNumOfNodes = seqIter.getNumOfChars();
		}

	public void createSites()
	{
		int count = 0;
		while( seqIter.hasNext() )
		{
				String subString = (String) seqIter.next();
				for( int i =0; i < subString.length(); i++ )
				{
					SiteNode curr = new SiteNode(count, this);
					sites.add(curr);
					count++;
				}
		}	
	}
	
	public void lengthen(int newLength)
	{
		// add gaps to fit length
		//SiteNode lastNode = (SiteNode)sites.get(endNumOfNodes-1);
		String endString; // = seqIter.getSubStringByPosition( seqIter.seqStrings.size() - 1 ); 
		
		for (int i = endNumOfNodes; i < newLength; i++)
		{
			endString ="-";
			seqIter.add( endString );
			
//			SiteNode newSite = new SiteNode(i, this);
//			lastNode.postorderNextNode = newSite;
//			sites.add(newSite);
//			lastNode = newSite;
		}
//		endNumOfNodes = sites.size();
	}

	
	public ArrayList getStringArray()
	{
		return seqIter.seqStrings;
	}
	
	public ArrayList getSites()
	{
		return sites;
	}
	
	public void setKey(int key)
	{
		this.key = key;
	}
	
	public int getNumOfNodes()
	{
		return seqIter.getNumOfChars();
	}
	
	public int getTotalNodeCount()
	{
		return endNumOfNodes;
	}
	
	public String getName()
	{
		return name;
	}
	
	public SiteNode getLeftmostLeaf()
	{
		int i = 0;
		SiteNode currNode = (SiteNode)sites.get(i);
		while (currNode.isGap())
			currNode = (SiteNode)sites.get(++i);
		return currNode;
	}
	
	public SiteNode getRightmostLeaf()
	{
		int i = sites.size() - 1;
		SiteNode currNode = (SiteNode)sites.get(i);
		while (currNode.isGap())
			currNode = (SiteNode)sites.get(--i);
		return currNode;
	}
	
	// for labeling (and looking at labels)
	public SiteNode getNode(int position)
	{
		if (position < sites.size() && position >= 0)
			return (SiteNode)sites.get(position);
		return null;
	}
		
	public char getNodeName(int position)
	{
		if (position >= 0 && position <= endNumOfNodes)
			return seqIter.charAt(position);
		System.out.println("error: bad position: " + position);
		return '-';
	}
	
	public int getHeight()
	{
		return 1;
	}
	
	public int getKey()
	{
		return key;
	}
	
	
		public void printAsPositions()
			{
				System.out.print(name + " [");
				for (int i = 0; i < sites.size()-1; i++)
				{
					System.out.print(((SiteNode)sites.get(i)).getPosition() + ",");
				}
				if (sites.size() > 0)
					System.out.print(((SiteNode)sites.get(sites.size()-1)).getPosition());
				System.out.println("]");
			} 
	
//	public SiteNode getPre()
//	{
//		return preorderStartNode;
//	}
//	
//	public SiteNode getPost()
//		{
//			return postorderStartNode;
//		}
	public SequenceStringIterator getIterator()
	{
		return seqIter;
	}
		
	public String getSubstring(int min, int max)
	{
		String returnString = "";
		if (min < 0) min++;
		for (int i = min; i <= max; i++)
		{
			char currChar = seqIter.charAt(i);
			if (currChar != '-')
				returnString += currChar;
		}
		return returnString;
	}
	
	private ArrayList getRegExprArray(String src)
	{
		final String openBrackets = "({[<";
		final String closedBrackets = ")}]>";
		if (src == null || src.length() == 0)
			return null;
		ArrayList returnList = new ArrayList();
		for (int i = 0; i < src.length(); i++)
		{
			char currChar = src.charAt(i);
			String currPosString = "";
			if (Character.isWhitespace(currChar))
				continue;
			if (openBrackets.indexOf(currChar) >= 0)
			{
				currChar = src.charAt(++i);
				while (closedBrackets.indexOf(currChar) == -1)
				{
					if (!Character.isWhitespace(currChar) ||
							currChar != ',')
						currPosString += currChar;
					currChar = src.charAt(++i);
				}
			}
			else
				currPosString += currChar;
			returnList.add(currPosString);
		}
		return returnList;
	}
	
	// amino character - 'A' = index, stop is Z + 1 for now
	//  (not sure how to represent it as a letter, maybe one of the unused characters (B, J, O, U, X, Z)?)
	// first 3 arrays are 3 positions in codon
	// last array is list of valid amino acids for a final check (i.e. {IG} doesn't match 
	static final String[][][] amino = {
		{ {"G"}, {"C"}, {"N"}, {
			"GCT", "GCC", "GCA", "GCG",
			"NCT", "NCC", "NCA", "NCG",
			"GNT", "GNC", "GNA", "GNG",
			"NNT", "NNC", "NNA", "NNG",
			"GCN", "NCN", "GNN", "NNN"} }, // A Alanine
		null, // B, no amino acid
		{ {"T"}, {"G"}, {"T", "C"}, {
			"TGT", "TGC", "NGC", "NGT",
			"TGN", "NGN", "TNC", "TNT",
			"TNN", "NNC", "NNT", "NNN"} }, // C Cysteine
		{ {"G"}, {"A"}, {"T", "C"}, {
			"GAT", "GAC", "GAN", "NAC",
			"NAT", "NAN", "GNC", "GNT",
			"GNN", "NNC", "NNT", "NNN"} }, // D Aspartic acid
		{ {"G"}, {"A"}, {"A", "G"}, {
			"GAA", "GAG", "GAN", "NAA",
			"NAG", "NAN", "GNA", "GNG",
			"GNN", "NNA", "NNG", "NNN"} }, // E Glutamic acid
		{ {"T"}, {"T"}, {"T", "C"}, {
			"TTT", "TTC", "TTN", "NTC",
			"NTT", "NTN", "TNC", "TNT",
			"TNN", "NNC", "NNT", "NNN"} }, // F Phenylalanine
		{ {"G"}, {"G"}, {"N"}, {
			"GGT", "GGC", "GGA", "GGG", 
			"GGN", "NGA", "NGC", "NGG", 
			"NGT", "NGN", "GNA", "GNC", 
			"GNG", "GNT", "GNN", "NNA", 
			"NNC", "NNG", "NNT", "NNN"} }, // G Glycine
		{ {"C"}, {"A"}, {"T", "C"}, {
			"CAT", "CAC", "CAN", "NAC",
			"NAT", "NAN", "CNC", "CNT",
			"CNN", "NNC", "NNT", "NNN" } }, // H Histidine
		{ {"A"}, {"T"}, {"T", "C", "A"}, {
			"ATT", "ATC", "ATA", "ATN",
			"NTA", "NTC", "NTT", "NTN",
			"ANA", "ANC", "ANT", "ANN",
			"NNA", "NNC", "NNT", "NNN"} }, // I Isoleucine
		null, // J, no amino acid
		{ {"A"}, {"A"}, {"A", "G"}, {
			"AAA", "AAG", "AAN", "NAA",
			"NAG", "NAN", "ANA", "ANG",
			"ANN", "NNA", "NNG", "NNN"} }, // K Lysine
		{ {"C", "T"}, {"T"}, {"N"}, {
			"CTT", "CTC", "CTA", "CTG",
			"TTA", "TTG", "CTN", "TTN",
			"NTA", "NTC", "NTG", "NTT",
			"NTN", "CNA", "CNC", "CNG",
			"CNT", "CNN", "TNA", "TNG",
			"TNN", "NNA", "NNC", "NNG",
			"NNT", "NNN"} }, // L Leucine
		{ {"A"}, {"T"}, {"G"}, {
			"ATG", "ATN", "NTG", "NTN",
			"ANG", "ANN", "NNG", "NNN"} }, // M Methionine
		{ {"A"}, {"A"}, {"T", "C"}, {
			"AAT", "AAC", "AAN", "NAC",
			"NAT", "NAN", "ANC", "ANT",
			"ANN", "NNC", "NNT", "NNN"} }, // N Asparagine
		null, // O, no amino acid
		{ {"C"}, {"C"}, {"N"}, {
			"CCT", "CCC", "CCA", "CCG",
			"CCN", "NCA", "NCC", "NCG",
			"NCT", "NCN", "CNA", "CNC",
			"CNG", "CNT", "CNN", "NNA",
			"NNC", "NNG", "NNT", "NNN"} }, // P Proline
		{ {"C"}, {"A"}, {"A", "G"}, {
			"CAA", "CAG", "CAN", "NAA",
			"NAG", "NAN", "CNA", "CNG",
			"CNN", "NNA", "NNG", "NNN"} }, // Q Glutamine
		{ {"C", "A"}, {"G"}, {"N"}, {
			"CGT", "CGC", "CGA", "CGG",
			"AGA", "AGG", "AGN", "CGN",
			"NGA", "NGC", "NGG", "NGT",
			"NGN", "ANA", "ANG", "ANN",
			"CNA", "CNC", "CNG", "CNT",
			"CNN", "NNA", "NNC", "NNG",
			"NNT", "NNN"} }, // R Arginine
		{ {"T", "A"}, {"C", "G"}, {"N"}, {
			"TCT", "TCC", "TCA", "TCG",
			"AGT", "AGC", "TCN", "NCA",
			"NCC", "NCG", "NCT", "NCN",
			"AGN", "NGC", "NGT", "NGN",
			"ANC", "ANT", "ANN", "TNA",
			"TNC", "TNG", "TNT", "TNN",
			"NNA", "NNC", "NNG", "NNT",
			"NNN"} }, // S Serine
		{ {"A"}, {"C"}, {"N"}, {
			"ACT", "ACC", "ACA", "ACG",
			"ACN", "NCA", "NCC", "NCG",
			"NCT", "NCN", "ANA", "ANC",
			"ANG", "ANT", "ANN", "NNA",
			"NNC", "NNG", "NNT", "NNN"} }, // T Threonine
		null, // U, no amino acid
		{ {"G"}, {"T"}, {"N"}, {
			"GTT", "GTC", "GTA", "GTG",
			"GTN", "NTA", "NTC", "NTG",
			"NTT", "NTN", "GNA", "GNC",
			"GNG", "GNT", "GNN", "NNA",
			"NNC", "NNG", "NNT", "NNN"} }, // V Valine
		{ {"T"}, {"G"}, {"G"}, {
			"TGG", "TGN", "NGG", "NGN",
			"TNG", "TNN", "NNG", "NNN"} }, // W Tryptophan
		null, // X, no amino acid
		{ {"T"}, {"A"}, {"T", "C"}, {
			"TAT", "TAC", "TAN", "NAC",
			"NAT", "NAN", "TNC", "TNT",
			"TNN", "NNC", "NNT", "NNN"} }, // Y Tyrosine
		null, // Z, no amino acid
		{ {"T"}, {"A", "G"}, {"A", "G"}, {
			"TAA", "TAG", "TGA", "NAA",
			"NAG", "TAN", "NAN", "TGN",
			"NGA", "NGN", "TNA", "TNG",
			"TNN", "NNA", "NNG", "NNN"} } // Stop 
	};
	
	private ArrayList getAminoListFromAmino(String src)
	{
		final String openBrackets = "({[<";
		final String closedBrackets = ")}]>";
		if (src == null || src.length() == 0)
			return null;
		ArrayList tempList = new ArrayList();
		for (int i = 0; i < src.length(); i++)
		{
			char currChar = src.charAt(i);
			String currPosString = "";
			if (Character.isWhitespace(currChar))
				continue;
			if (openBrackets.indexOf(currChar) >= 0)
			{
				currChar = src.charAt(++i);
				while (closedBrackets.indexOf(currChar) == -1)
				{
					if (!Character.isWhitespace(currChar) ||
						currChar != ',')
						currPosString += currChar;
					currChar = src.charAt(++i);
				}
			}
			else
				currPosString += currChar;
			tempList.add(currPosString);
		}
		return tempList;
	}
	
	private ArrayList getDNAFromAmino(String src)
	{
		ArrayList tempList = getAminoListFromAmino(src);
		// tempList is built, now expand it into DNA
		if (tempList == null || tempList.size() == 0)
			return null;
		ArrayList returnList = new ArrayList(tempList.size() * 3); // DNA return string
		for (int i = 0; i < tempList.size(); i++) // size is as long as the search string
		{
			String[] tempString = {"", "", ""};
			String posString = ((String)tempList.get(i)).toUpperCase();
			for (int j = 0; j < posString.length(); j++) // length is typically 1-3 characters
			{
				char currResidue = posString.charAt(j);
				for (int k = 0; k < 3; k++) // always 3 nucleotides per amino acid
				{
					if (currResidue == '.')
						tempString[k] = "N";
					else
					{
						String[] basePairK = amino[currResidue - 'A'][k];
						for (int l = 0; l < basePairK.length; l++) // all possible base pairs
						{
							String currChar = basePairK[l];
							if (currChar.equalsIgnoreCase("N") || tempString[k].indexOf("N") >= 0)
								tempString[k] = "N";
							else if (!(tempString[k].indexOf(currChar) >= 0))
								tempString[k] += currChar;
						}
					}
				}
			}
			for (int k = 0; k < 3; k++)
				returnList.add(tempString[k]);
		}
		return returnList;
	}
	
	private boolean backCheckSequence(int start, int end, String proteinString)
	{
		ArrayList proteinList = getAminoListFromAmino(proteinString);
		// rebuild DNA string, no gaps, must be a multiple of 3 at this point...
		String DNAstring = "";
		for (int i = start; i <= end; i++)
		{
			char currChar = seqIter.charAt(i);
			if (currChar == '-') // skip gaps in search string src
				continue;
			DNAstring += currChar;
		}
		if (DNAstring.length() % 3 != 0 || DNAstring.length() / 3 != proteinList.size())
			return false; // error in length of DNA string
			
		// examine each segment of the protein
		for (int i = 0; i < proteinList.size(); i++) // each segment of protein, single amino acid positions
		{
			String currDNA = DNAstring.substring(i*3, i*3+3);
			String currProtein = (String)proteinList.get(i);
			boolean foundCurrPosition = false; // set this to true when this position is ok
			for (int j = 0; j < currProtein.length() && !foundCurrPosition; j++) // each part of the current protein segment
			{
				char currProteinChoice = currProtein.charAt(j);
				if (currProteinChoice == '.')
					foundCurrPosition = true;
				else
				{
					String[] proteinPossibilities = amino[currProteinChoice - 'A'][3];
					for (int k = 0; k < proteinPossibilities.length && !foundCurrPosition; k++) // protein possibilities
					{
						if (currDNA.equalsIgnoreCase(proteinPossibilities[k]))	
							foundCurrPosition = true;
					}
				}
			}
			if (!foundCurrPosition)
				return false;
		}
		return true;
	}
	
	// src has no gaps
	// return a rangelist (list of rangeinsequence)
	// set the key of the rangelist later
	// draw
	// nMatchesEverything is true when we want to treat 'N' as a wildcard in the sequence
	// 'N' is always treated as a wildcard when it is in the search string (src)
	public RangeList search(String srcString, int cutoff, boolean draw, boolean nMatchesEverything, boolean aminoAcids)
	{
		ArrayList src;
		if (aminoAcids)
			src = getDNAFromAmino(srcString);
		else
			src = getRegExprArray(srcString);
		RangeList returnList = new RangeList(-1);
		if (src == null || src.size() == 0)
			return returnList;
		String firstChar = (String)src.get(0);
		char theFirstChar = firstChar.charAt(0);
		for (int i = 0; i < seqIter.getNumOfChars() && returnList.size() <= cutoff; i++) // go down the sequence looking for search string src
		{
			char currChar = seqIter.charAt(i);
			if (currChar == '-') // skip gaps in search string src
				continue;
			if ((firstChar.length() == 1 && (theFirstChar == currChar || theFirstChar == 'N')) || // first character is not a regexp
				firstChar.indexOf(currChar) >= 0 || // match the first character with src first character 
				firstChar.indexOf('N') >= 0 || // first character of src is N, might be better to find first non-N in src.. but would have to count backwards
									// from first non-N when something is found 
				(currChar == 'N' && nMatchesEverything)) // character in sequence is N and N is wildcard
			{
				int k = i+1;
				boolean found = true;
				for (int j = 1; j < src.size() && found; j++, k++)
				{
					while (k < seqIter.getNumOfChars() && seqIter.charAt(k) == '-') // find next non-gap
						k++;
					if (k == seqIter.getNumOfChars())
					{
						found = false;
						break;
					}
					char seqIterChar = seqIter.charAt(k);
					String currSrcString = (String)src.get(j);
					char theCurrSrcChar = currSrcString.charAt(0);
					if (k < (seqIter.getNumOfChars()-1) && 			// k is still within the sequence
					  (currSrcString.length() == 1 && (theCurrSrcChar == 'N' || theCurrSrcChar == seqIter.charAt(k))) ||
						(currSrcString.indexOf('N') >= 0 || 	// wildcard for search sequence, match anything in sequence
						 currSrcString.indexOf(seqIterChar) >= 0 || // exact match, keep looking for failure
						 (nMatchesEverything && seqIterChar == 'N')) // N matches and found an N
						 )
						continue; // continue if positive match 
					found = false; // break for loop condition, no match
				}
				if (found)
				{
					if (!aminoAcids)
						returnList.addRange(i, k-1, this, draw, true);
					else if (backCheckSequence(i, k-1, srcString))
						returnList.addRange(i, k-1, this, draw, true);
				}
			}
			if (returnList.size() > cutoff)
				return null;
		}
//		System.out.println(this + " found: " + returnList);
		return returnList;
	}
	
	public String toString()
	{
		return name + "(" + endNumOfNodes + ")";
	}

	public static Color getColor(int num)
	{
		if (num == 6)
			return gapColor;
		else if (num == 7)
			return diffColor;
		else if (num == 8)
			return foundColor;
		return col[num];
	}

	// able to get a Color without instantiating a SequenceCell (if no SequenceCells are available)
	public static Color getColor(char letter)
	{
		switch (letter)
		{
			case 'A':
			case 'a': return col[A];
			case 'T':
			case 't': return col[T];
			case 'C':
			case 'c': return col[C];
			case 'G':
			case 'g': return col[G];
			case 'U':
			case 'u': return col[U];
			case '-': return gapColor;
			case 'N':
			case 'n': return col[N];
			case 'F':
			case 'f': return foundColor;
			case 'R':
			case 'W':
			case 'Y': return diffColor;
			default: return diffColor;
		}
			
	}

	public static void setColor(char letter, Color color)
	{
		switch (letter)
		{
			case 'A':
			case 'a': col[A] = color; return;
			case 'T':
			case 't': col[T] = color; return;
			case 'C':
			case 'c': col[C] = color; return;
			case 'G':
			case 'g': col[G] = color; return;
			case 'U':
			case 'u': col[U] = color; return;
			case 'N':
			case 'n': col[N] = color; return;
			case '-': gapColor = color; return;
			case 'F':
			case 'f': foundColor = color; return;
			default: diffColor = color; return;
		}
	}
	
	// return a node in this range that has a gridcell and is not a gap
	// change this to use the gap range list
	public SiteNode getNodeInRange(int min, int max)
	{
//		System.out.println("get node in: " + this + " " + min + " " + max);
		SiteNode currNode = getNode(min);
		if (!currNode.isGap())
			return currNode;
		else
		{
			// range to match
			RangeInSequence fakeRange = new RangeInSequence(min+1, max-1, this);
			
			RangeList.matchRange = null;
			RangeList.returnObject = true;
			currNode = null; // still is null if the range isn't found or the range is beyond max
			
			RangeList group = AccordionSequenceDrawer.gapRangeList;
			if (true == group.getEnabled() && group.getRanges().contains(fakeRange))
			{
				RangeInSequence foundRange = RangeList.matchRange;
				RangeList.matchRange = null;
				if (foundRange != null && foundRange.max+1 <= max)
					currNode = getNode(foundRange.max+1); // returns null if out of bounds
			}
			RangeList.returnObject = false;
			RangeList.matchRange = null;
		}
		return currNode;
	}
	
	public Vector getAnnotationList()
	{
		return this.annotationList;
	}
	
	// x is a window position (0 to 1)
	public SiteNode pickSiteNode(double x, SplitLine splitLine, double pixelSize)
	{
		int sitePosition = splitLine.getSplitLineIndex(x, pixelSize, asd.getFrameNum());
		if (sitePosition < 0 || sitePosition > endNumOfNodes-1)
			return null;
		SplitCell sc = new SplitCell(sitePosition);
		SplitCell foundSite = SplitCell.getOverlapSplitCell(asd.listOfSites, sc);
		return getNode(foundSite.max);
	}
	
	/**
	 * @return Returns the asd.
	 */
	public AccordionSequenceDrawer getAsd() {
		return asd;
	}
	/**
	 * @param asd The asd to set.
	 */
	public void setAsd(AccordionSequenceDrawer asd) {
		this.asd = asd;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.OlduvaiObject#getMinObjectKey()
	 */
	public int getMinObjectKey() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.OlduvaiObject#getMaxObjectKey()
	 */
	public int getMaxObjectKey() {
		// TODO Auto-generated method stub
		return sites.size();
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.OlduvaiObject#getMinObjectValue()
	 */
	public float getMinObjectValue() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.OlduvaiObject#getMaxObjectValue()
	 */
	public float getMaxObjectValue() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.OlduvaiObject#getObjectKeyAt(int)
	 */
	public int getObjectKeyAt(int i) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.OlduvaiObject#getObjectValueAt(int)
	 */
	public float getObjectValueAt(int i) {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see AccordionDrawer.OlduvaiObject#getObjects()
	 */
	public ArrayList getObjects() {
		// TODO Auto-generated method stub
		return sites;
	}
	
	public int getMinLine()
	{
		return key - 1;
	}
	
	public int getMaxLine()
	{
		return key;
	}
}
