/*
 * Created on 30-Apr-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package SeqParser;

import java.io.*;
import java.util.*;
import java.util.regex.*;

import SequenceJuxtaposer.*;
import AccordionSequenceDrawer.*;

/**
 * @author hilde
 *
 * parsing annotations from a flat file 
 * several feature are ignored in front of the ranges
 * 
 */
public class FlatFileLoader {

	boolean eof = false; // class wide EOF
	int key = 0;
	// general file information like sequence name etc
	
	String seqName;
	SequenceJuxtaposer sj;
	
	public FlatFileLoader(SequenceJuxtaposer sj, String filename, int maxload) throws FileNotFoundException
	//public FlatFileLoader( String filename ) throws FileNotFoundException
	{
			seqName = new String();
			this.sj = sj;
			try
			{
					BufferedReader br = new BufferedReader( new FileReader( filename ) );
					
					Sequence seq = null;
					while( !eof )
					{
						System.out.println("new sequence");
					//	seq = readFlatFileData( br );
						seq = getFileInformation( br );	
						sj.addSequence(seq);
						
						// to make this more dynamic we need a max annotationnum
						if( seq.getAnnotationList().size() > SequenceJuxtaposer.maxAnnotationNum )
						{
							SequenceJuxtaposer.maxAnnotationNum = seq.getAnnotationList().size();
							SequenceJuxtaposer.seqNumWithMaxAnnotation = key;	
						}
						
					}
					// after create sequences - add to groups
					// this has to be done before you call createASD()
					sj.addAnnotationGroups();
					
					
										
					sj.createASD();
					System.out.println(" here is correct");
			} 
			catch( IOException e)
			{
				System.err.println("is that really a flat file format??" + e.getMessage());
			}
	
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	boolean checkGlobalAnnotationVector( String str )
	{
		boolean found = false;
		
		for( int i=0; i<sj.foundFeatures.size(); i++)
		{
			if( ((String)sj.foundFeatures.get(i)).equalsIgnoreCase( str ))
				found = true;		
		}
		return found;
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// get Flat File information 
	
	Sequence getFileInformation( BufferedReader b ) throws IOException
	{
		Vector al = new Vector();
		System.out.println("get file information...");
		BufferedReader featureBr = getGeneralFileInformation( b );
		String newLine = featureBr.readLine();
		Sequence seq;		
		String next_prefix = "  ";
		StringBuffer features = new StringBuffer() ;
		
		// get one big string
		while( newLine.startsWith( next_prefix ) ) 
		{
				features.append( newLine ) ;
				newLine = featureBr.readLine();
		}
		
		// how many feature are in that file?
		StringTokenizer ft = new StringTokenizer( features.toString() );
		while( ft.hasMoreTokens() )
		{
			String word = ft.nextToken();
			
			for( int i =0; i<Annotation.feature.length; i++)
			{					
					if( word.equalsIgnoreCase( Annotation.feature[i] ))
					{
//						for an automated process,  register this string globally in SJ
						if( !checkGlobalAnnotationVector( Annotation.feature[i] ))
							sj.foundFeatures.add( Annotation.feature[i] );
							 					
						if( al.size() == 0 )
						{
							Annotation annotation = new Annotation( Annotation.feature[i] );
							al.add( annotation );
						}
						else
						{
								// already in there?
								boolean found = false;
								for( int a = 0; a<al.size(); a++)  
								{
									if( (Annotation.feature[i] == ((Annotation)al.get(a)).getName()) ) {
										found = true; break; }							
								}
								// if not - please add here
								if( !found )
								{
									Annotation annotation = new Annotation( Annotation.feature[i] );
									al.add( annotation );							
									// for an automated process,  register this string globally in SJ
								}
						}
				
						String[] range;
						if( (range = getFeature( ft, word, Annotation.feature[i])) != null)
						{
							
							// add range to the correct annotation
							for( int j =0; j< al.size(); j++) 
							{ 
								if( Annotation.feature[i] == ((Annotation)al.get(j)).getName() )
								{
									((Annotation)al.get(j)).addRange( range[0], range[1] );
									System.out.println("range "+ range[0] + " " + range[1]);
								}
							}
						}
				} // end if equals
			} // end for
		}
		
		// before the base pairs you can always find
		String prefix = "ORIGIN";			
		while ( !newLine.startsWith( prefix ) )
		{
			  newLine = featureBr.readLine();
		}
			
		ArrayList seqStr = new ArrayList();
		seqStr = getDNA( b );
		System.out.println("Sequence " + seqName);
		seq =  new Sequence( seqName, seqStr, al, key++ );
		return seq;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	String[] getFeature( StringTokenizer ft, String word, String regex )
	{
			ArrayList all  = new ArrayList();
			String INPUT;
			boolean found = false;
			
			if( word.equalsIgnoreCase( regex ))
			{
					String region = ft.nextToken();
					// because a feature always has a regions, which can be one the complement
					// site, I can hardcode that here
					Pattern pattern2 = Pattern.compile( "complement" );
					Matcher matcher2 = pattern2.matcher( region );
					
					
					if( matcher2.find() )
					{
						region = region.substring( matcher2.end()+1, region.length()-1 );
						return region.split("\\..");	
					}
					else
					{
						return region.split("\\..");
					}
					
			}
			
			return null;
			
	}


	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	BufferedReader getGeneralFileInformation( BufferedReader br ) throws IOException
	{
		String line = br.readLine();
		
		if (line == null) 
			  throw new IOException("EOF");

		while(line.length() == 0) 
		{
			line = br.readLine();
			if (line == null) 
					throw new IOException("EOF");
		}
		
		
		String prefix = "SOURCE";
		while( !line.startsWith( prefix ) )
		{
			line = br.readLine();
		}
		seqName = line.trim().substring(6).trim();
		
		prefix = "FEATURES";
		while( !line.startsWith( prefix ) )
		{
			line = br.readLine();
		}
		
		
		return br;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	public ArrayList getDNA( BufferedReader br )
	{
		System.out.println("getting DNA...");
		ArrayList seqStrings = new ArrayList();
		boolean end = false;
		char[] cache = new char[512];
		String seqPart = "";
		StringBuffer sb = new StringBuffer();
		int len = 0;
	
		try
		{
			while( !end )
			{
				int c = br.read( );
			
				// TODO multiple strings
				if( c == -1 )
				{
					System.out.println(" endof file");
					end = true;
					eof = true;
					//System.out.println("string" + sb.toString() + " "  + sb.length());
				
					seqStrings.add( sb.substring( 0, len ).toUpperCase() );
					//System.out.println("string" + sb.toString() + " "  + sb.length() + " " + sb.charAt(0));
				
					return seqStrings;
				}
			
				// don't read number or whitespace
				char ca = (char)c;
				if( ca  == '/')
				{
					end = true;
					seqStrings.add( sb.substring( 0, len ).toUpperCase() );
					//System.out.println("string" + sb.toString() + " "  + sb.length() + " " + sb.charAt(0));
					
					if( isTheEnd( br ) )
						eof = true;
						
					return seqStrings;
				}
			
				if( ca != ' ' && (ca < '0'  || ca > '9') && ca != '\n' && ca != '\r')
				{
					sb.append( ca );
					len = sb.length();
				}
			}
		}
		catch( IOException e )
		{
			System.err.println(" bytes read error ");
		}
	
		
		return seqStrings;
	}
	
	boolean isTheEnd( BufferedReader b ) throws IOException
	{
		// the end is either eof or \n
		if( ((b.read() == '/' && b.read() == -1)) || b.readLine() == null )
			return true;
		else 
			return false;
	}

	public String getLocus( BufferedReader br )
	{
		return "";
	}

	public String getDefinition( BufferedReader br )
	{
			return "";
	}

	public String getSource( BufferedReader br )
	{
		return "";
	}

	public String getOrganism( BufferedReader br )
	{
		return "";
	}

	public String getAccession( BufferedReader br )
	{
		return "";
	}

	public String getVersion( BufferedReader br )
	{
		return "";
	}
	
	public String getComent( BufferedReader br )
	{
		return "";
	}

//	public static void main(String[] args) {
//
//		try {
//				FlatFileLoader ffl = new FlatFileLoader("../../data/annotation_files/15889.gbk");
//					
//				} catch (FileNotFoundException e) {
//					//System.out.println("File not found " + fileName);
//					e.printStackTrace();
//				} 
//
//		 
//		
//	}
}

