/*
 * Created on 2003-10-22
 * User Interface part of code for TreeJuxtaposer 
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package SequenceJuxtaposer;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import java.io.*;

import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;


/**
 * @author jeffrey
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class UI implements ActionListener, ChangeListener {
	Frame mainFrame;
	String title;
	GroupFrame groupFrame;
	boolean groupFrameVisible = false;
	AnnotationFrame annotationFrame;
	boolean annotationFrameVisible = false;
	boolean annotationOn = true; // to dynamically create buttons
	
	//		SettingsFrame settingsFrame;
	//		IncrementalSearch searchFrame;
	//		DebugFrame debugFrame;
	JPanel controlPanel;
	Panel drawPanel;
	GridLayout drawLayout;
	//screen size	   
	Toolkit toolkit = Toolkit.getDefaultToolkit();
	Dimension screendim = toolkit.getScreenSize();
	final JFileChooser fc = new JFileChooser();
	boolean firstTime = true;
	/* Variables and constants for the menu bar */
	MenuBar menuBar;
	MenuItem menuItem[][];
	static final String MENUFONTTYPE = "Helvetica";
	static final int MENUFONTSTYLE = Font.BOLD;
	static final int MENUFONTSIZE = 10;
	/* top-level menu bar constants */
//	static final String menuHeader[] = { "File", "Tools", "Readme" };
//	static final int FILEMENU = 0;
//	static final int TOOLMENU = 1;
//	static final int HELPMENU = 2;
//	static final Menu menu[] =
//		{
//			new Menu(menuHeader[FILEMENU]),
//			new Menu(menuHeader[TOOLMENU]),
//			new Menu(menuHeader[HELPMENU])};

	/* component-level menu bar constants
	 * string to describe the menu options, null is for a separator
	 * boolean to describe whether menu option is active
	 * integer for enumerating menu options
	 */
	static final String menu[] = { "Open", "Tools",  "Annotation", "Help", "Quit", };
//	static final boolean fileActive[] = { true, true };
	static final int OPENOPT = 0;
	static final int TOOLOPT = 1;
	static final int ANNOOPT = 2;
	static final int HELPOPT = 3;
	static final int QUITOPT = 4;
	Button optionButton[];
	

//	static final String toolMenu[] = {};
//	static final boolean toolActive[] = {};
//
//	static final String helpMenu[] = {};
//	static final boolean helpActive[] = {};
//	
//	// over-declared to make construction shorter
//	static final String allMenu[][] =
//		{ fileMenu, toolMenu, helpMenu };
//	static final boolean allActive[][] =
//		{ fileActive, toolActive, helpActive };

	SequenceJuxtaposer sj;

	JSlider diffChangeSlider = new JSlider();
	JLabel diffChangeLabel = new JLabel("Difference");

	public UI(SequenceJuxtaposer sj, String title) {
		this.sj = sj;
		mainFrame = new Frame(title);
		mainFrame.setLocation(10, 30);
		mainFrame.setLayout(new BorderLayout());
		controlPanel = new JPanel();
		drawPanel = new Panel();
		drawLayout = new GridLayout(1, 1, 0, 4); // do row/column additions at SeqJux level
																			// when adding components
		drawPanel.setLayout(drawLayout);
		//mainFrame.getContentPane().add(controlPanel, BorderLayout.NORTH);
		//mainFrame.add(drawPanel, BorderLayout.CENTER);
		sj.searchPanel = new Panel();
		sj.optionBar = new JPanel(new BorderLayout());
		optionButton = new Button[menu.length];
		Panel smallPanel = new Panel();
		for (int i = 0; i < optionButton.length; i++)
		{
			
			optionButton[i] = new Button(menu[i]);
			optionButton[i].setFont(new Font(MENUFONTTYPE, MENUFONTSTYLE, MENUFONTSIZE));
			if (i < optionButton.length - 1)
				smallPanel.add(optionButton[i]);
			else
				sj.optionBar.add(optionButton[i], BorderLayout.EAST);
			optionButton[i].addActionListener(this);
		}
		sj.optionBar.add(smallPanel, BorderLayout.WEST);
//		sj.mainFrame.add(optionBar, BorderLayout.NORTH);
		fc.addChoosableFileFilter(new FastaFilter());
		fc.setMultiSelectionEnabled(true);
	
		int diff =(int)( sj.getDifferenceValue()*100);
		diffChangeSlider = new JSlider(JSlider.HORIZONTAL,0,100, diff);
		diffChangeSlider.setPreferredSize(new Dimension(100, diffChangeSlider.getPreferredSize().height *2));
		diffChangeSlider.addChangeListener(this);
		diffChangeSlider.setMajorTickSpacing(5);
		//diffChangeSlider.setSnapToTicks(false);
		diffChangeSlider.setPaintTicks(true);
		
		sj.optionBar.add(diffChangeSlider, BorderLayout.CENTER);
		
		groupFrame = new GroupFrame(sj);
		
		 /* 
			settingsFrame = new SettingsFrame(sj);
			searchFrame = new IncrementalSearch(sj);
			debugFrame = new DebugFrame(sj); */
//		addMenuBar();
//		menuBar.setFont(new Font(MENUFONTTYPE, MENUFONTSTYLE, MENUFONTSIZE));
	}

//	private void addMenuBar() {
//		JPopupMenu.setDefaultLightWeightPopupEnabled(false);
//		menuBar = new MenuBar();
//		menuItem = new MenuItem[menuHeader.length][];
//		for (int i = 0; i < menuHeader.length; i++) {
//			menuItem[i] = new MenuItem[allMenu[i].length];
//			for (int j = 0; j < allMenu[i].length; j++) {
//				if (allMenu[i][j] == null)
//					menu[i].addSeparator();
//				else {
//					menuItem[i][j] = new MenuItem(allMenu[i][j]);
//					menuItem[i][j].setEnabled(allActive[i][j]);
//					menu[i].add(menuItem[i][j]);
//				}
//			}
//			menuBar.add(menu[i]);
//		}
//		mainFrame.setMenuBar((MenuBar) menuBar);
//
//		/* Events */
//		menuItem[FILEMENU][OPENOPT].addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				sj.addAction();
//			}
//		});
//
//		menuItem[FILEMENU][QUITOPT].addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				sj.quitAction();
//			}
//		});
//}

	protected Frame getMainFrame() {
		return mainFrame;
	}
	protected Panel getDrawPanel() {
		return drawPanel;
	}
	protected JPanel getControlPanel() {
		return controlPanel;
	}
	protected GridLayout getDrawLayout() {
		return drawLayout;
	}
	//   protected IncrementalSearch getSearchFrame(){
	//		return searchFrame;
	//	}
	//    protected SettingsFrame getSettingsFrame(){
	//    	return settingsFrame;
	//    }
	//    protected DebugFrame getDebugFrame(){
	//    	return debugFrame;
	//    }
	//    protected StateFrame getStateFrame(){
	//    	return stateFrame;
	//    }
	protected void addAction() {
		// fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
		if (firstTime) {
			fc.setCurrentDirectory(new File("."));
			firstTime = false;
		}
		int returnVal = fc.showOpenDialog(mainFrame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			//				File file = fc.getSelectedFile();
			File[] files = fc.getSelectedFiles();
			for (int i = 0; i < files.length; i++) {
				boolean fasta_file;
				String s = null;
				// It would be better to rely on the parser to
				// figure out the format of the file. The one
				// implemented here is an ad-hoc solution.
				if (fc.getFileFilter().accept(files[i]))
					fasta_file = true;
				else
					fasta_file = false;
				try {
					//				s = file.getCanonicalPath();
					s = files[i].getCanonicalPath();
					System.out.println(
						"YZ File.getCanonicalPath() fname: " + s);
					if (fasta_file) {
						System.out.println("Load fasta file " + s);
						sj.loadFasta(s, Integer.MAX_VALUE);
					}
				} catch (Exception ex) {
					System.out.println("File not found: " + s);
					ex.printStackTrace();
				}
			}
		}
	}

	protected void quitAction() {
		// add other actions if needed when the quit menu option is selected
		System.exit(0);
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		if (!(e.getSource() instanceof Button)) return;
		Button b = (Button)e.getSource();
		if (b == optionButton[OPENOPT])
		{
			sj.addAction();
		}
		else if (b == optionButton[TOOLOPT]) {
			showGroupFrame();
		}
		else if (b == optionButton[ANNOOPT]) {
			showAnnotationFrame();
		}
		else if (b == optionButton[HELPOPT])
		{
			new Help().showAboutFrame();
		}
		else if (b == optionButton[QUITOPT])
		{
			System.exit(0);
		}
		
	}
	
	public void showGroupFrame(){
		if (mainFrame.getLocation().y + mainFrame.getHeight()	+ 30 + groupFrame.getHeight()	< screendim.height)
			groupFrame.setLocation(10,mainFrame.getLocation().y + mainFrame.getHeight() + 30);
		else
			groupFrame.setLocation(10,screendim.height - groupFrame.getHeight());
		
		groupFrameVisible = (groupFrameVisible == false) ? true : false;
		groupFrame.show();
		groupFrame.setVisible(groupFrameVisible);
		
	}
	
	public void showAnnotationFrame()
	{
		// instance after first buttonPress
		if( annotationOn ) {
			annotationFrame = new AnnotationFrame(sj);
			annotationOn = false;	
		}
		if( SequenceJuxtaposer.maxAnnotationNum > 0 ) {
		
		if (mainFrame.getLocation().y + mainFrame.getHeight()	+ 30 + annotationFrame.getHeight()	< screendim.height)
			annotationFrame.setLocation(10,mainFrame.getLocation().y + mainFrame.getHeight() + 30);
		else
			annotationFrame.setLocation(10,screendim.height - annotationFrame.getHeight());
		
		annotationFrameVisible = (annotationFrameVisible == false) ? true : false;
		annotationFrame.show();
		annotationFrame.setVisible(annotationFrameVisible);
		
		}
	}
	
	public void stateChanged(ChangeEvent e)
		{
			if ( e.getSource()  == diffChangeSlider)
			{
						float diff = (float)diffChangeSlider.getValue();
						sj.setDifferenceValue(diff/100.0f);
			}
		}

}
